package org.wikimedia.discovery.cirrus.updater.common.config;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;
import java.util.Comparator;
import java.util.EnumSet;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Optional;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.logging.Logger;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.stream.StreamSupport;

import org.apache.flink.configuration.ConfigOption;
import org.apache.flink.configuration.FallbackKey;
import org.apache.flink.configuration.description.Formatter;
import org.apache.flink.configuration.description.TextElement.TextStyle;

import com.github.difflib.text.DiffRow;
import com.github.difflib.text.DiffRow.Tag;
import com.github.difflib.text.DiffRowGenerator;

import edu.umd.cs.findbugs.annotations.SuppressFBWarnings;

@SuppressWarnings("HideUtilityClassConstructor")
@SuppressFBWarnings(
        value = {"HideUtilityClassConstructor", "RFI_SET_ACCESSIBLE"},
        justification = "constructor: lombok takes care of that; reflection: there is no alternative")
public class ConfigRenderer {

    private static final Method CONFIG_OPTION_METHOD_GETCLAZZ;
    private static final Method CONFIG_OPTION_METHOD_ISLIST;

    private static final Locale LOCALE = Locale.ENGLISH;

    static {
        try {
            CONFIG_OPTION_METHOD_GETCLAZZ = ConfigOption.class.getDeclaredMethod("getClazz");
            CONFIG_OPTION_METHOD_GETCLAZZ.setAccessible(true);
            CONFIG_OPTION_METHOD_ISLIST = ConfigOption.class.getDeclaredMethod("isList");
            CONFIG_OPTION_METHOD_ISLIST.setAccessible(true);
        } catch (NoSuchMethodException e) {
            throw new IllegalStateException("Unable to extract config option type method", e);
        }
    }

    private static Class<?> getOptionType(ConfigOption<?> option) {
        try {
            return (Class<?>) CONFIG_OPTION_METHOD_GETCLAZZ.invoke(option);
        } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
            throw new RuntimeException("Failed to call " + CONFIG_OPTION_METHOD_GETCLAZZ, e);
        }
    }

    private static boolean isList(ConfigOption<?> option) {
        try {
            return (boolean) CONFIG_OPTION_METHOD_ISLIST.invoke(option);
        } catch (IllegalAccessException | IllegalArgumentException | InvocationTargetException e) {
            throw new RuntimeException("Failed to call " + CONFIG_OPTION_METHOD_ISLIST, e);
        }
    }

    private enum Goal {
        render,
        verify
    }

    /**
     * Renders config options as markdown to a specified file.
     *
     * <p>Example: <code>
     *     org.wikimedia.discovery.cirrus.updater.producer.config.ProducerConfig \
     *     ../cirrus-streaming-updater-producer/CONFIG.md \
     *     verify|render
     *   </code>
     *
     * @param args 1..3 arguments: FQN of the config class[, an output path[, goal {verify, render}]]
     */
    public static void main(String[] args) {
        final Goal goal = args.length > 2 ? Goal.valueOf(args[2]) : Goal.render;

        try {
            final Class<? extends CommonConfig> configClass =
                    (Class<? extends CommonConfig>) Class.forName(args[0]);
            final Stream<Class<?>> configClasses = Stream.of(configClass, CommonConfig.class);

            if (args.length > 1) {
                final Path path = Path.of(args[1]);

                final String content =
                        configClasses.map(ConfigRenderer::renderMarkdown).collect(Collectors.joining("\n\n"))
                                + "\n\nThis file has been auto-generated by `"
                                + ConfigRenderer.class.getCanonicalName()
                                + "`.\n";

                if (goal == Goal.verify) {
                    final List<String> originalLines = Files.readAllLines(path);
                    final List<String> revisedLines = List.of(content.split("\n"));

                    if (!originalLines.equals(revisedLines)) {
                        final StringBuilder diffBuilder = renderDiff(originalLines, revisedLines);

                        throw new IllegalStateException(
                                String.format(
                                        LOCALE,
                                        "Contents of %s (last modified %s) do not match rendered content.\n"
                                                + "Run with goal 'render' to update and see the difference:\n\n%s",
                                        path,
                                        Files.getLastModifiedTime(path),
                                        diffBuilder));
                    }
                } else {
                    Files.writeString(
                            path,
                            content,
                            StandardCharsets.UTF_8,
                            StandardOpenOption.CREATE,
                            StandardOpenOption.TRUNCATE_EXISTING);
                }
            } else {
                final Logger logger = Logger.getLogger(ConfigRenderer.class.getSimpleName());
                configClasses.forEach(
                        clazz -> {
                            final String content = render(clazz);
                            logger.info(String.format(LOCALE, "Config options for %s:%n%s%n", clazz, content));
                        });
            }
        } catch (ClassNotFoundException | IOException e) {
            throw new RuntimeException("Failed to " + goal, e);
        }
    }

    public static String render(Class<?> configClass) {
        final List<ConfigOption<?>> options =
                Stream.of(configClass.getDeclaredFields())
                        .filter(
                                field ->
                                        ConfigOption.class.isAssignableFrom(field.getType())
                                                && Modifier.isStatic(field.getModifiers())
                                                && Modifier.isPublic(field.getModifiers()))
                        .map(
                                field -> {
                                    try {
                                        return (ConfigOption<?>) field.get(null);
                                    } catch (IllegalAccessException | ClassCastException e) {
                                        throw new RuntimeException(
                                                "Failed to read config option field " + field.getName(), e);
                                    }
                                })
                        .sorted(Comparator.comparing(ConfigOption::key))
                        .collect(Collectors.toList());
        return render(options);
    }

    public static String render(List<ConfigOption<?>> options) {
        final int maxKeyLength =
                options.stream()
                        .flatMap(
                                option ->
                                        Stream.concat(
                                                Stream.of(option.key()),
                                                StreamSupport.stream(option.fallbackKeys().spliterator(), false)
                                                        .map(FallbackKey::getKey)))
                        .mapToInt(String::length)
                        .max()
                        .orElse(0);

        final int leftOffset = maxKeyLength + 4;
        final PlaintextFormatter plaintextFormatter = new PlaintextFormatter(LOCALE, leftOffset);

        return options.stream()
                .map(
                        option -> {
                            final Class<?> type = getOptionType(option);
                            final boolean list = isList(option);
                            return String.format(
                                    LOCALE,
                                    "--%-" + (leftOffset - 2) + "s%s\n" + "%" + leftOffset + "s%s",
                                    option.key(),
                                    plaintextFormatter.format(option.description()),
                                    type.getSimpleName() + (list ? "[]" : "") + "  ",
                                    Optional.ofNullable(option.defaultValue())
                                            .map(
                                                    defaultValue ->
                                                            defaultValue instanceof Map && !(defaultValue instanceof SortedMap)
                                                                    ? new TreeMap<>((Map<?, ?>) defaultValue)
                                                                    : defaultValue)
                                            .map(defaultValue -> "default: " + defaultValue + "\n")
                                            .orElse(""));
                        })
                .collect(Collectors.joining("\n"));
    }

    public static String renderMarkdown(Class<?> configClass) {
        final String output = ConfigRenderer.render(configClass);
        return "# Configuration parameters for "
                + configClass.getSimpleName()
                + "\n\n```\n"
                + output
                + "\n```";
    }

    public static StringBuilder renderDiff(List<String> originalLines, List<String> revisedLines) {
        DiffRowGenerator generator = DiffRowGenerator.create().build();
        final List<DiffRow> diffRows = generator.generateDiffRows(revisedLines, originalLines);

        StringBuilder diffBuilder = new StringBuilder();
        for (int diffLineIndex = 0; diffLineIndex < diffRows.size(); diffLineIndex++) {
            final DiffRow diffRow = diffRows.get(diffLineIndex);
            if (diffRow.getTag() == Tag.EQUAL) {
                continue;
            }
            diffBuilder.append(
                    String.format(
                            Locale.ENGLISH,
                            "%4d %6s:%n%s%n%s%n",
                            diffLineIndex + 1,
                            diffRow.getTag().name(),
                            diffRow.getOldLine(),
                            diffRow.getNewLine()));
        }
        return diffBuilder;
    }
}

class PlaintextFormatter extends Formatter {

    final int leftOffset;
    final Locale locale;

    PlaintextFormatter(Locale locale, int leftOffset) {
        this.locale = locale;
        this.leftOffset = leftOffset;
    }

    @Override
    protected void formatLineBreak(StringBuilder state) {
        state.append(String.format(locale, "\n%-" + leftOffset + "s", ""));
    }

    @Override
    protected void formatLink(StringBuilder state, String link, String description) {
        if (description != null && !description.isEmpty() && !description.equals(link)) {
            state.append(description).append(" (").append(link).append(')');
        } else {
            state.append(link);
        }
    }

    @Override
    protected void formatList(StringBuilder state, String[] entries) {
        Stream.of(entries)
                .forEach(
                        entry -> state.append(String.format(locale, "\n%" + leftOffset + "s * %s", "", entry)));
    }

    @Override
    protected void formatText(
            StringBuilder state, String format, String[] elements, EnumSet<TextStyle> styles) {
        state.append(String.format(locale, format, (Object[]) elements));
    }

    @Override
    protected Formatter newInstance() {
        return new PlaintextFormatter(locale, leftOffset);
    }
}
